----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    11:15:24 07/27/2019 
-- Design Name: 
-- Module Name:    SinProject - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.std_logic_unsigned.all;
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity SinProject is
    Port ( clk : in  STD_LOGIC;
	        reset : in  STD_LOGIC;
           Kat : in  STD_LOGIC_VECTOR (9 downto 0);
           DataOut : out  STD_LOGIC_VECTOR (31 downto 0);
           strobe : in  STD_LOGIC);
end SinProject;

architecture Behavioral of SinProject is
   
   COMPONENT ROM_Sinus90
     PORT (
       clka : IN STD_LOGIC;
       addra : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
       douta : OUT STD_LOGIC_VECTOR(31 DOWNTO 0)
     );
  END COMPONENT;
  
  signal KatUnsigned : unsigned(9 downto 0); -- definicja syg lokalnego	
  signal AddressUnsigned : unsigned(7 downto 0); -- definicja syg lokalnego
  signal AddressInteger : integer range 0 to 256 :=0;
  signal AddressSinus: STD_LOGIC_VECTOR(7 DOWNTO 0);
  signal WartSinus :  STD_LOGIC_VECTOR(31 DOWNTO 0);
  signal ZnakSinus : integer range -1 to 1;  

begin
  
  SEQ: process (reset, clk, strobe)
  begin
    if (reset = '0') then
--	   DataOut <= x"00000000";		
    elsif ((clk' event and clk = '1' ) and (strobe' event and strobe = '1' )) then   
      KatUnsigned <= unsigned(Kat);
		if (KatUnsigned < 256) then
		   AddressUnsigned <= KatUnsigned(7 DOWNTO 0);
			AddressSinus <= std_logic_vector(AddressUnsigned);
			ZnakSinus <= 1;
		elsif ((KatUnsigned >= 256) and (KatUnsigned < 512)) then
		   AddressInteger <= (254 - (to_integer(KatUnsigned)-256));
			AddressSinus <= std_logic_vector(to_unsigned(AddressInteger, AddressSinus'length));
			ZnakSinus <= 1;
		elsif ((KatUnsigned >= 512) and (KatUnsigned <= 767)) then
		   AddressInteger <= (to_integer(KatUnsigned)-512);
			AddressSinus <= std_logic_vector(to_unsigned(AddressInteger, AddressSinus'length));
			ZnakSinus <= -1;	
		elsif ((KatUnsigned > 767) and (KatUnsigned <= 1023)) then
		   AddressInteger <= (254 -(to_integer(KatUnsigned)-768));
			AddressSinus <= std_logic_vector(to_unsigned(AddressInteger, AddressSinus'length));
			ZnakSinus <= -1;		
		else	
			AddressSinus <= b"00000000";
		end if;
	 
    end if;
  end process;
  
  
  TableSinus90 : ROM_Sinus90
  PORT MAP (
    clka => clk,
    addra => AddressSinus,
    douta => WartSinus
  );

 SEQ1: process (clk)
 begin 
   if (clk' event and clk = '1') then    
     if (ZnakSinus > 0) then
       DataOut <= WartSinus;
     else
       DataOut <= (b"1" & WartSinus(30 DOWNTO 0));
     end if; 
   end if;	  
 end process;

end Behavioral;

